(function () {
    if (window.maxthon.V) {
        return;
    }
    var V =  window.V = window.maxthon.V = {
        createVBox: function (callback, avatar_type, avatar_data, name, chain) {
            var json = {
                avatar_type: avatar_type, avatar_data: avatar_data, name: name, chain: chain
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "createVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        deleteVBox: function (callback, password, public_key) {
            var json = {
                password: password, public_key: public_key
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "deleteVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifyVBox: function (callback, public_key, type, data) {
            var json = {
                public_key: public_key, type: type, data: data
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "modifyVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifyVBoxAvatar: function (callback, public_key, avatar_type, avatar_data) {
            var json = {
                public_key: public_key, avatar_type: avatar_type, avatar_data: avatar_data
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "modifyVBoxAvatar", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        resetVBoxPassword: function (callback, old_password, new_password) {
            var json = {
                 old_password: old_password, new_password: new_password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "resetVBoxPassword", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        exportVBox: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "exportVBox", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        importVBox: function (callback, body, password) {
            var json = {
                 body: body, password: password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "importVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getVBoxs: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "getVBoxs", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        clearVBox: function (callback, clear_cloud) {
            var json = {
                clear_cloud: clear_cloud
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "clearVBox", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        loginCloud: function (callback, account, token) {
            var json = {
                account: account, token: token
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "loginCloud", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        continueLoginCloud: function (callback, content) {
            var json = {
                content: content
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "continueLoginCloud", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        closeCloud: function (callback) {
            connectWebViewJavascriptBridge(function () {1111111
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "closeCloud", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getCloudStatus: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "getCloudStatus", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getSignDatas: function (callback, password) {
            var json = {
                password: password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "getSignDatas", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        addSignData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "addSignData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifySignData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "modifySignData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        deleteSignData: function (callback, public_key, id) {
            var json = {
                public_key: public_key, id: id
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "deleteSignDatas", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getPayDatas: function (callback, public_key, password) {
            var json = {
                public_key: public_key, password: password
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "getPayDatas", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        addPayData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "addPayData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        modifyPayData: function (callback, js_object) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "modifyPayData", "data": JSON.stringify(js_object) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        deletePayData: function (callback, public_key, id) {
            var json = {
                public_key: public_key, id: id
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "deletePayData", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getPassQuota: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "getPassQuota", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        setPassQuota: function (callback, password, quota) {
            var json = {
                password: password, quota: quota
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "setPassQuota", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getDayPassQuota: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "getDayPassQuota", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        setDayPassQuota: function (callback, password, quota) {
            var json = {
                password: password, quota: quota
            };

            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "setDayPassQuota", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        authorizeConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "authorizeConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        getFee: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "getFee", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        payConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "payConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        signAuthorizeConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "signAuthorizeConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        signConfirm: function (callback, json_string) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "signConfirm", "data": json_string },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        setDefaultIdentity: function (callback, json_string, chain) {
            var json = {
                address: json_string,
                chain:chain
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "setDefaultIdentity", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        registerSyncEvent: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.registerHandler(
                    'onMaxthonVboxSyncEventCallback',
                    function(data, responseCallback) {
                        responseCallback(callback(data));
                    });
                let last_identity_time = JSON.parse(maxthon.getLocalVboxData()).last_identity_time;
                let data = JSON.stringify({
                    code:200, 
                    last_sync_time: parseInt(last_identity_time / 1000)
                });
                callback(data);
            });
        },
        startSync: function (callback) {
            var json = {
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "startSync", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        scanQRCode: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "scanQRCode", "data": JSON.stringify({}) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        passwordCorrect: function (callback, password) {
            var json = {
                password: password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "passwordCorrect", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        verifyPrivateKey: function (callback, key, chain) {
            var json = {
                key: key,
                chain: chain
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "verifyPrivateKey", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        importPrivateKey: function (callback, private_key, password, name,  chain) {
            var json = {
                private_key: private_key, password: password, name: name, chain: chain
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "importPrivateKey", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        
        updateNBdomain: function (callback, domain, address, json_object) {
            var json = {
                domain: domain, address: address, json_object: json_object
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "updateNBdomain", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        registNotifyFunction: function (callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.registerHandler(
                    'onMaxthonVboxWebNotifyEventCallback',
                    function(data, responseCallback) {
                        responseCallback(callback(data));
                    });
            });
        },
        payIDConfirm: function (callback,id, confirm,password) {
            var json = {
                id: id, confirm: confirm, password: password
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "payIDConfirm", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        paySwitchAccount: function (callback,id, public_key, ndaccount) {
            var json = {
                id: id, public_key: public_key, ndaccount: ndaccount
            };
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "paySwitchAccount", "data": JSON.stringify(json) },
                    function (responseData) {
                        callback(responseData);
                    }
                );
            });
        },
        close:function() {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "close", "data": JSON.stringify({}) },
                    function (responseData) {
                    }
                );
            });
        },
        request:function(para, callback) {
            connectWebViewJavascriptBridge(function () {
                WebViewJavascriptBridge.callHandler(
                    'callHandler',
                    { "action": "request", "data": JSON.stringify(para) },
                    function (responseData) {
                        if (callback != null) {
                            callback(responseData);
                        }
                    }
                );
            });
        }
    };

    var readyEvent = document.createEvent('Events');
    readyEvent.initEvent('VBoxReady');
    readyEvent.V = V;
    document.dispatchEvent(readyEvent);
})();

